<template>
  <div v-if="loaded" class="card">
    <v-tabs v-model="tab" bg-color="w" color="yellow-darken-3" grow>
      <v-tab value="one">
        <p>รอการอนุมัติ</p>
      </v-tab>
      <v-tab value="two">
        <p>รายการยืม</p>
      </v-tab>
      <v-tab value="three">
        <p>รายการที่ต้องคืน</p>
      </v-tab>
      <v-tab value="four">
        <p>รอการอนุมัติรับคืน</p>
      </v-tab>
      <v-tab value="five">
        <p>สำเร็จ</p>
      </v-tab>
      <v-tab value="zero">
        <p>ยกเลิก</p>
      </v-tab>
    </v-tabs>

    <v-card-text>
      <v-window v-model="tab">
        <v-window-item value="one">
          <v-infinite-scroll mode="manual" max-height="1000">
            <template v-for="(request) in waitingForApproval" :key="request">
              <v-expansion-panels class="px-1 py-1">
                <v-expansion-panel>
                  <v-expansion-panel-title>
                    <v-img v-if="request.equipment.image && request.equipment.image.length > 0"
                      :src="media + request.equipment.image[0].url" :aspect-ratio="1" width="70" class="img" cover />
                    <img v-else src="/assets/image/non-equipment.jpg" :aspect-ratio="1" width="70" class="img" cover />
                    <div class="d-flex px-2 detail">
                      <p v-if="request.equipment.name.length <= 20">{{ request.equipment.name }}</p>
                      <p v-else>{{ request.equipment.name.slice(0, 20) }}...</p>
                    </div>
                    <p class="text-yellow-darken-3 text-sm text-wrap align-center pr-3 text-end">รออนุมัติ</p>
                  </v-expansion-panel-title>
                  <div class="d-flex flex-row">
                    <p class="text-sm ml-3 text-no-wrap">{{ request.equipment.provider_name }}</p>
                    <p class="text-id text-end align-self-center pr-2">รายการ {{ request.id }}</p>
                  </div>
                  <v-expansion-panel-text>
                    <div class="d-flex flex-column border-t-sm">
                      <div class="d-flex">
                        <p class="text-sm">รายละเอียด</p>
                        <p v-if="request.equipment.detail" class="text-sm">{{ request.equipment.detail }}</p>
                        <p v-else> - </p>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">ระยะเวลาในการยืม</p>
                        <p class="text-sm">{{ request.equipment.day_limit }} <span>วัน</span></p>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">จำนวน</p>
                        <p class="text-sm">× 1</p>
                      </div>
                      <div class="d-flex">
                        <span class="text-time">ส่งคำขอเมื่อ {{ formatDateTime(request.createdAt) }}</span>
                      </div>
                      <v-btn :v-model="cancleId = request.id" @click="onCancle" :loading="btnLoading" block
                        class="text-none mt-2" color="yellow-darken-3" size="small" variant="outlined">
                        ยกเลิก
                      </v-btn>
                    </div>
                  </v-expansion-panel-text>
                </v-expansion-panel>
              </v-expansion-panels>
            </template>

            <template v-slot:load-more>
              no more
            </template>
          </v-infinite-scroll>
        </v-window-item>

        <v-window-item value="two">
          <v-infinite-scroll mode="manual" max-height="1000">
            <template v-for="(request) in borrowingList" :key="request">
              <v-expansion-panels class="px-1 py-1">
                <v-expansion-panel>
                  <v-expansion-panel-title>
                    <v-img v-if="request.equipment.image && request.equipment.image.length > 0"
                      :src="media + request.equipment.image[0].url" :aspect-ratio="1" width="70" class="img" cover />
                    <img v-else src="/assets/image/non-equipment.jpg" :aspect-ratio="1" width="70" class="img" cover />
                    <div class="d-flex px-2 detail">
                      <p v-if="request.equipment.name.length <= 20">{{ request.equipment.name }}</p>
                      <p v-else>{{ request.equipment.name.slice(0, 20) }}...</p>
                    </div>
                    <p class="text-green-darken-3 text-sm text-wrap align-center pr-3 text-end">อยู่ระหว่างการยืม</p>
                  </v-expansion-panel-title>
                  <div class="d-flex flex-row">
                    <p class="text-sm ml-3 text-no-wrap">{{ request.equipment.provider_name }}</p>
                    <p class="text-id text-end align-self-center pr-2">รายการ {{ request.id }}</p>
                  </div>
                  <v-expansion-panel-text>
                    <div class="d-flex flex-column border-t-sm">
                      <div class="d-flex">
                        <p class="text-sm">รายละเอียด</p>
                        <p v-if="request.equipment.detail" class="text-sm">{{ request.equipment.detail }}</p>
                        <p v-else> - </p>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">ระยะเวลาในการยืม</p>
                        <p class="text-sm">{{ request.equipment.day_limit }} <span>วัน</span></p>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">จำนวน</p>
                        <p class="text-sm">× 1</p>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">กำหนดการคืน</p>
                        <p class="text-sm">{{ formatDateThai(request.return_schedule) }}</p>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">ผู้อนุมัติยืม</p>
                        <p class="text-sm">{{ request.giver }}</p>
                      </div>
                      <div class="d-flex">
                        <span class="text-time">อนุมัติเมื่อ {{ formatDateTime(request.borrowed) }}</span>
                      </div>
                      <v-btn :v-model="borrowId = request.id" @click="onReturnBefore" :loading="btnLoading" block
                        class="text-none mt-2" color="green-darken-3" size="small" variant="outlined">
                        ขอคืนก่อนกำหนด
                      </v-btn>
                    </div>
                  </v-expansion-panel-text>
                </v-expansion-panel>
              </v-expansion-panels>
            </template>

            <template v-slot:load-more>
              no more
            </template>
          </v-infinite-scroll>
        </v-window-item>

        <v-window-item value="three">
          <v-infinite-scroll mode="manual" max-height="1000">
            <template v-for="(request) in returnList" :key="request">
              <v-expansion-panels class="px-1 py-1">
                <v-expansion-panel>
                  <v-expansion-panel-title>
                    <v-img v-if="request.equipment.image && request.equipment.image.length > 0"
                      :src="media + request.equipment.image[0].url" :aspect-ratio="1" width="70" class="img" cover />
                    <img v-else src="/assets/image/non-equipment.jpg" :aspect-ratio="1" width="70" class="img" cover />
                    <div class="d-flex px-2 detail">
                      <p v-if="request.equipment.name.length <= 20">{{ request.equipment.name }}</p>
                      <p v-else>{{ request.equipment.name.slice(0, 20) }}...</p>
                    </div>
                    <p class="text-orange-darken-3 text-sm text-wrap align-center pr-3 text-end">ครบกำหนดคืน</p>
                  </v-expansion-panel-title>
                  <div class="d-flex flex-row">
                    <p class="text-sm ml-3 text-no-wrap">{{ request.equipment.provider_name }}</p>
                    <p class="text-id text-end align-self-center pr-2">รายการ {{ request.id }}</p>
                  </div>
                  <v-expansion-panel-text>
                    <div class="d-flex flex-column border-t-sm">
                      <div class="d-flex">
                        <p class="text-sm">รายละเอียด</p>
                        <p v-if="request.equipment.detail" class="text-sm">{{ request.equipment.detail }}</p>
                        <p v-else> - </p>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">ระยะเวลาในการยืม</p>
                        <p class="text-sm">{{ request.equipment.day_limit }} <span>วัน</span></p>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">จำนวน</p>
                        <p class="text-sm">× 1</p>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">กำหนดการคืน</p>
                        <p class="text-sm text-orange-darken-3">{{ formatDateThai(request.return_schedule) }}</p>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">ผู้อนุมัติยืม</p>
                        <p class="text-sm">{{ request.giver }}</p>
                      </div>
                      <div class="d-flex">
                        <span class="text-time">อนุมัติเมื่อ {{ formatDateTime(request.borrowed) }}</span>
                      </div>
                      <v-btn :v-model="borrowId = request.id" @click="onReturn" :loading="btnLoading" block
                        class="text-none mt-2" color="orange-darken-3" size="small" variant="outlined">
                        คืนอุปกรณ์
                      </v-btn>
                    </div>
                  </v-expansion-panel-text>
                </v-expansion-panel>
              </v-expansion-panels>
            </template>

            <template v-slot:load-more>
              no more
            </template>
          </v-infinite-scroll>
        </v-window-item>

        <v-window-item value="four">
          <v-infinite-scroll mode="manual" max-height="1000">
            <template v-for="(request) in waitingForReturnApproval" :key="request">
              <v-expansion-panels class="px-1 py-1">
                <v-expansion-panel>
                  <v-expansion-panel-title>
                    <v-img v-if="request.equipment.image && request.equipment.image.length > 0"
                      :src="media + request.equipment.image[0].url" :aspect-ratio="1" width="70" class="img" cover />
                    <img v-else src="/assets/image/non-equipment.jpg" :aspect-ratio="1" width="70" class="img" cover />
                    <div class="d-flex px-2 detail">
                      <p v-if="request.equipment.name.length <= 20">{{ request.equipment.name }}</p>
                      <p v-else>{{ request.equipment.name.slice(0, 20) }}...</p>
                    </div>
                    <p class="text-teal-darken-2 text-sm text-wrap align-center pr-3 text-end">รออนุมัติ</p>
                  </v-expansion-panel-title>
                  <div class="d-flex flex-row">
                    <p class="text-sm ml-3 text-no-wrap">{{ request.equipment.provider_name }}</p>
                    <p class="text-id text-end align-self-center pr-2">รายการ {{ request.id }}</p>
                  </div>
                  <v-expansion-panel-text>
                    <div class="d-flex flex-column border-t-sm">
                      <div class="d-flex">
                        <p class="text-sm">รายละเอียด</p>
                        <p v-if="request.equipment.detail" class="text-sm">{{ request.equipment.detail }}</p>
                        <p v-else> - </p>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">ระยะเวลาในการยืม</p>
                        <p class="text-sm">{{ request.equipment.day_limit }} <span>วัน</span></p>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">จำนวน</p>
                        <p class="text-sm">× 1</p>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">กำหนดการคืน</p>
                        <p class="text-sm">{{ formatDateThai(request.return_schedule) }}</p>
                      </div>
                      <div class="d-flex">
                        <span class="text-time">ส่งคำขอคืนเมื่อ {{ formatDateTime(request.updatedAt) }}</span>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">ผู้อนุมัติยืม</p>
                        <p class="text-sm">{{ request.giver }}</p>
                      </div>
                      <div class="d-flex">
                        <span class="text-time">อนุมัติเมื่อ {{ formatDateTime(request.borrowed) }}</span>
                      </div>
                    </div>
                  </v-expansion-panel-text>
                </v-expansion-panel>
              </v-expansion-panels>
            </template>

            <template v-slot:load-more>
              no more
            </template>
          </v-infinite-scroll>
        </v-window-item>

        <v-window-item value="five">
          <v-infinite-scroll mode="manual" max-height="1000">
            <template v-for="(request) in successList" :key="request">
              <v-expansion-panels class="px-1 py-1">
                <v-expansion-panel>
                  <v-expansion-panel-title>
                    <v-img v-if="request.equipment.image && request.equipment.image.length > 0"
                      :src="media + request.equipment.image[0].url" :aspect-ratio="1" width="70" class="img" cover />
                    <img v-else src="/assets/image/non-equipment.jpg" :aspect-ratio="1" width="70" class="img" cover />
                    <div class="d-flex px-2 detail">
                      <p v-if="request.equipment.name.length <= 20">{{ request.equipment.name }}</p>
                      <p v-else>{{ request.equipment.name.slice(0, 20) }}...</p>
                    </div>
                    <p class="text-green text-sm text-wrap align-center pr-3 text-end">สำเร็จ</p>
                  </v-expansion-panel-title>
                  <div class="d-flex flex-row">
                    <p class="text-sm ml-3 text-no-wrap">{{ request.equipment.provider_name }}</p>
                    <p class="text-id text-end align-self-center pr-2">รายการ {{ request.id }}</p>
                  </div>
                  <v-expansion-panel-text>
                    <div class="d-flex flex-column border-t-sm">
                      <div class="d-flex">
                        <p class="text-sm">รายละเอียด</p>
                        <p v-if="request.equipment.detail" class="text-sm">{{ request.equipment.detail }}</p>
                        <p v-else> - </p>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">ระยะเวลาในการยืม</p>
                        <p class="text-sm">{{ request.equipment.day_limit }} <span>วัน</span></p>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">จำนวน</p>
                        <p class="text-sm">× 1</p>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">กำหนดการคืน</p>
                        <p class="text-sm">{{ formatDateThai(request.return_schedule) }}</p>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">ผู้อนุมัติยืม</p>
                        <p class="text-sm">{{ request.giver }}</p>
                      </div>
                      <div class="d-flex">
                        <span class="text-time">อนุมัติเมื่อ {{ formatDateTime(request.borrowed) }}</span>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">ผู้อนุมัติคืน</p>
                        <p class="text-sm">{{ request.receiver }}</p>
                      </div>
                      <div class="d-flex">
                        <span class="text-time">อนุมัติเมื่อ {{ formatDateTime(request.returned) }}</span>
                      </div>
                      <v-btn :v-model="borrowAgainID = request.equipment.id" @click="onBorrowAgain"
                        :loading="btnLoading" block class="text-none mt-2" color="grey-darken-4" size="small"
                        variant="outlined">
                        ยืมอีกครั้ง
                      </v-btn>
                    </div>
                  </v-expansion-panel-text>
                </v-expansion-panel>
              </v-expansion-panels>
            </template>

            <template v-slot:load-more>
              no more
            </template>
          </v-infinite-scroll>
        </v-window-item>

        <v-window-item value="zero">
          <v-infinite-scroll mode="manual" max-height="1000">
            <template v-for="(request) in cancleList" :key="request">
              <v-expansion-panels class="px-1 py-1">
                <v-expansion-panel>
                  <v-expansion-panel-title>
                    <v-img v-if="request.equipment.image && request.equipment.image.length > 0"
                      :src="media + request.equipment.image[0].url" :aspect-ratio="1" width="70" class="img" cover />
                    <img v-else src="/assets/image/non-equipment.jpg" :aspect-ratio="1" width="70" class="img" cover />
                    <div class="d-flex px-2 detail">
                      <p v-if="request.equipment.name.length <= 20">{{ request.equipment.name }}</p>
                      <p v-else>{{ request.equipment.name.slice(0, 20) }}...</p>
                    </div>
                    <p class="text-red text-sm text-wrap align-center pr-3 text-end">ยกเลิก</p>
                  </v-expansion-panel-title>
                  <div class="d-flex flex-row">
                    <p class="text-sm ml-3 text-no-wrap">{{ request.equipment.provider_name }}</p>
                    <p class="text-id text-end align-self-center pr-2">รายการ {{ request.id }}</p>
                  </div>
                  <v-expansion-panel-text>
                    <div class="d-flex flex-column border-t-sm">
                      <div class="d-flex">
                        <p class="text-sm">รายละเอียด</p>
                        <p v-if="request.equipment.detail" class="text-sm">{{ request.equipment.detail }}</p>
                        <p v-else> - </p>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">ระยะเวลาในการยืม</p>
                        <p class="text-sm">{{ request.equipment.day_limit }} <span>วัน</span></p>
                      </div>
                      <div class="d-flex">
                        <p class="text-sm">จำนวน</p>
                        <p class="text-sm">× 1</p>
                      </div>
                      <div class="d-flex">
                        <span class="text-time">ยกเลิกเมื่อ {{ formatDateTime(request.updatedAt) }}</span>
                      </div>
                      <v-btn :v-model="borrowAgainID = request.equipment.id" @click="onBorrowAgain"
                        :loading="btnLoading" block class="text-none mt-2" color="grey-darken-4" size="small"
                        variant="outlined">
                        ยืมอีกครั้ง
                      </v-btn>
                    </div>
                  </v-expansion-panel-text>
                </v-expansion-panel>
              </v-expansion-panels>
            </template>

            <template v-slot:load-more>
              no more
            </template>
          </v-infinite-scroll>
        </v-window-item>
      </v-window>
    </v-card-text>
  </div>
  <div v-if="!loaded" class="card d-flex flex-column mb-2">
    <v-skeleton-loader type="heading"></v-skeleton-loader>
    <v-skeleton-loader type="list-item-avatar"></v-skeleton-loader>
    <v-skeleton-loader type="list-item-two-line"></v-skeleton-loader>
    <v-skeleton-loader type="list-item-avatar"></v-skeleton-loader>
    <v-skeleton-loader type="list-item-two-line"></v-skeleton-loader>
    <v-skeleton-loader type="list-item-avatar"></v-skeleton-loader>
    <v-skeleton-loader type="list-item-two-line"></v-skeleton-loader>
    <v-skeleton-loader type="list-item-avatar"></v-skeleton-loader>
    <v-skeleton-loader type="list-item-two-line"></v-skeleton-loader>
    <v-skeleton-loader type="list-item-avatar"></v-skeleton-loader>
    <v-skeleton-loader type="list-item-two-line"></v-skeleton-loader>
    <v-skeleton-loader type="list-item-avatar"></v-skeleton-loader>
    <v-skeleton-loader type="list-item-two-line"></v-skeleton-loader>
  </div>
</template>

<script setup>
useHead({
  title: "ระบบยืม-คืน | รายการยืม-คืน",
  meta: [{ name: "description", content: "รายการยืม-คืน" }],
});
definePageMeta({
  middleware: "auth",
});

import { ref } from 'vue'
import axios from "axios"

const token = useStrapiToken();
const url = useStrapiUrl();
const media = useStrapiMedia();

const tab = ref(null)
const loaded = ref(false)

const waitingForApproval = ref([])
const borrowingList = ref([])
const returnList = ref([])
const waitingForReturnApproval = ref([])
const successList = ref([])
const cancleList = ref([])

const borrowingListDate = ref([])

const cancleId = ref()
const borrowId = ref()
const borrowAgainID = ref()
const btnLoading = ref(false)

async function onCancle() {
  btnLoading.value = true;
  console.log("Equipment ID : ", cancleId.value)
  const user = await useStrapiUser()

  await axios.put(`${url}/requests/${cancleId.value}`, {
    data: {
      status: 0
    }
  }, {
    headers: {
      Authorization: `Bearer ${token.value}`,
    }
  })

  btnLoading.value = false;
  await getBorrowingReturnList();
}

async function onReturnBefore() {
  btnLoading.value = true;
  await new Promise(resolve => setTimeout(resolve, 500));
  btnLoading.value = false;
  console.log("Return ID : ", borrowId.value)
  const user = await useStrapiUser()

  await axios.put(`${url}/requests/${borrowId.value}`, {
    data: {
      status: 4
    }
  }, {
    headers: {
      Authorization: `Bearer ${token.value}`,
    }
  })

  await getBorrowingReturnList();
}

async function onReturn() {
  btnLoading.value = true;
  await new Promise(resolve => setTimeout(resolve, 500));
  btnLoading.value = false;
  console.log("Return ID : ", borrowId.value)
  const user = await useStrapiUser()

  await axios.put(`${url}/requests/${borrowId.value}`, {
    data: {
      status: 4
    }
  }, {
    headers: {
      Authorization: `Bearer ${token.value}`,
    }
  })

  await getBorrowingReturnList();
}

async function onBorrowAgain() {
  btnLoading.value = true;
  await new Promise(resolve => setTimeout(resolve, 500));
  btnLoading.value = false;
  console.log("BorrowAgain ID : ", borrowAgainID.value)
  navigateTo(`/borrowing-confirmation/${borrowAgainID.value}`)
}

async function getBorrowingReturnList() {
  try {
    await axios.get(`${url}/users/me`, {
      params: {
        fields: {
          0: 'id'
        },
        populate: {
          requests: {
            populate: {
              equipment: {
                fields: {
                  1: 'name',
                  2: 'provider_name',
                  3: 'day_limit'
                },
                populate: {
                  image: {
                    fields: {
                      4: 'url'
                    }
                  }
                }
              }
            }
          },
        },
      },
      headers: {
        'Authorization': `Bearer ${token.value}`,
      }
    }).then((response) => {
      const requests = response.data.requests;
      waitingForApproval.value = requests.filter(request => request.status === 1).reverse();
      borrowingList.value = requests.filter(request => request.status === 2).reverse();
      returnList.value = requests.filter(request => request.status === 3).reverse();
      waitingForReturnApproval.value = requests.filter(request => request.status === 4).reverse();
      successList.value = requests.filter(request => request.status === 5).reverse();
      cancleList.value = requests.filter(request => request.status === 0).reverse();
    })

  } catch (error) {
    console.log("error : ", error)
  }
}

const formatDateThai = (dateStr) => {
  if (dateStr === null) {
    return 'Invalid date';
  }

  const monthsTh = ['มกราคม', 'กุมภาพันธ์', 'มีนาคม', 'เมษายน', 'พฤษภาคม', 'มิถุนายน', 'กรกฎาคม', 'สิงหาคม', 'กันยายน', 'ตุลาคม', 'พฤศจิกายน', 'ธันวาคม'];
  const parts = dateStr.split("-");
  const day = parseInt(parts[2], 10);
  console.log(day)
  const monthIndex = parseInt(parts[1], 10) - 1;
  const year = parseInt(parts[0], 10) + 543;
  return `${day} ${monthsTh[monthIndex]} ${year}`;
}

const formatDateTime = (timestamp) => {
  const utcDateTime = new Date(timestamp);
  const options = {
    year: 'numeric', month: '2-digit', day: '2-digit',
    hour: '2-digit', minute: '2-digit', second: '2-digit',
    timeZone: 'Asia/Bangkok'
  };
  return utcDateTime.toLocaleString('th-TH', options);
};

onMounted(async () => {
  await getBorrowingReturnList();
  loaded.value = true
})

</script>

<style scoped>
@import url(../assets/css/styles/borrowing-return.css);
</style>